type nat = | Z
          | S of nat

type 'a list =
  | Nil
  | Cons of 'a * 'a list

let rec add m n =
  match m with
  | Z -> n
  | S m' -> S (add m' n)

let add_gen = lifting add

type ornament 'a natlist : nat => 'a list with
  | Z => Nil
  | S xs => Cons(_,xs) when xs : 'a natlist

let append_incomplete = lifting add : _ natlist -> _ natlist -> _ natlist

let append = lifting add : _ natlist -> _ natlist -> _ natlist with
 | #3 <- match m with Cons(a,_) -> a

let rec nat2int n = match n with
 | Z -> Z
 | S m -> S (nat2int m)


let list_length = lifting nat2int : _ natlist -> nat

let rec copy n = match n with
 | Z -> Z
 | S m -> S (copy m)

let list2nat = lifting copy : _ natlist -> _ with
  ornament * <- @id
(*  with | ornament * <- @id *)
