#(mode genpatches)

type int = Integer

type string = String

type 'a option =
  | Some of 'a
  | None

type expr =
  | Abs of (expr -> expr)
  | App of expr * expr
  | Const of int

type location = Location of string * int * int

type expr' =
  | Abs' of ((expr' * location) -> (expr' * location))
  | App' of (expr' * location) * (expr' * location)
  | Const' of int

type relation add_loc : expr => (expr' * location) with
 | Abs f => (Abs' f, _) when f:(add_loc -> add_loc)
 | App (u, v) => (App' (u, v), _) when u:add_loc,v:add_loc
 | Const i => (Const' i, _)

type ('a,'err) result =
  | Ok of 'a
  | Error of 'err

type relation ('a,'err) optres : 'a option => ('a,'err) result with
 | Some a => Ok a
 | None => Error _

let rec eval e = match e with
    | App(u, v) ->
      begin match eval u with
        | Some (Abs f) -> eval (f v)
        | ((Some (App(_, _)) | Some (Const _)) | None) ->
          None
      end
    | _ -> Some e

let eval_loc = lifting eval : (add_loc -> (add_loc,location) optres) with
 patch begin match _a with
        | Error l -> Error (#[l])
   end
 patch match _a with
    | (App'(u, v), x) ->
      begin match _a with
        | (Ok (App'(_, _), _) | Ok (Const' _, _)) ->
          Error (#[x])
      end
