type expr' =
  | Const' of int
  | Add' of expr' * expr'
  | Mul' of expr' * expr'

let rec _eval' e = match e with
    | Const' i -> i
    | Add'(u, v) -> add (_eval' u) (_eval' v)
    | Mul'(_, _) -> #1

let rec eval' e = match e with
    | Const' i -> i
    | Add'(u, v) -> add (eval' u) (eval' v)
    | Mul'(x, x1) -> mul (eval' x) (eval' x1)
