type expr_de_bruijn =
  | App' of expr_de_bruijn * expr_de_bruijn
  | Const' of int
  | Abs' of expr_de_bruijn
  | Var' of int box

let rec assoc' n l = match l with
    | Nil -> None
    | Cons(b, q) ->
      begin match eq #20 #14 with
        | True -> Some b
        | False -> assoc' (Box #5) q
      end

let rec assoc' n l = match l with
    | Nil -> None
    | Cons(b, q) ->
      begin match eq zero
      begin match n with
          | Box a -> a
        end
        with
        | True -> Some b
        | False ->
          assoc'
          (Box (prev
            begin match n with
                | Box n' -> n'
              end))
          q
      end

let rec eval_bruijnified env e = match e with
    | Const' i -> Some (Const' i)
    | App'(a, b) ->
      begin match eval_bruijnified env b with
        | None -> None
        | Some a1 ->
          begin match eval_bruijnified env a with
            | Some (Abs' e) ->
              eval_bruijnified (Cons(a1, env)) e
            | _ -> None
          end
      end
    | Abs' e -> Some (Abs' e)
    | Var' n -> (lifting #10 of assoc) n env

let rec eval_bruijnified env e = match e with
    | Const' i -> Some (Const' i)
    | App'(a, b) ->
      begin match eval_bruijnified env b with
        | None -> None
        | Some a1 ->
          begin match eval_bruijnified env a with
            | Some (Abs' e) ->
              eval_bruijnified (Cons(a1, env)) e
            | _ -> None
          end
      end
    | Abs' e -> Some (Abs' e)
    | Var' n -> assoc' n env
