
# 34 "disorn_set.tex"
  type 'a map =
    | MEmpty
    | MNode of 'a map * elt * 'a * 'a map * int

  let minvalid_arg = MEmpty

  let mheight t = match t with
      | MEmpty -> i0
      | MNode(_, _, _, _, h) -> h

  let mcreate l vb r = match vb with
      | Box (a, x) ->
        let hl = match l with
            | MEmpty -> i0
            | MNode(_, _, _, _, n) -> n
        in
        let hr = match r with
            | MEmpty -> i0
            | MNode(_, _, _, _, n) -> n
        in
        let x1 = (* _2 *) gte hl hr in
        MNode(l,
         a,
         x,
         r,
         match x1 with
           | True -> plus hl i1
           | False -> plus hr i1
        )

  let mbal l vb r = match vb with
      | Box (a, x) ->
        let hl = match l with
            | MEmpty -> i0
            | MNode(_, _, _, _, n) -> n
        in
        let hr = match r with
            | MEmpty -> i0
            | MNode(_, _, _, _, n) -> n
        in
        match gt hl (plus hr i2) with
          | True ->
            begin match l with
              | MEmpty -> minvalid_arg
              | MNode(l, v, x1, r1, _) ->
                begin match gte (mheight l) (mheight r1) with
                  | True ->
                    mcreate l (Box (v, x1))
                    (mcreate r1 (Box (a, x)) r)
                  | False ->
                    begin match r1 with
                      | MEmpty -> minvalid_arg
                      | MNode(l1, v1, x2, r1, _) ->
                        mcreate (mcreate l (Box (v, x1)) l1)
                        (Box (v1, x2))
                        (mcreate r1 (Box (a, x)) r)
                    end
                end
            end
          | False ->
            begin match gt hr (plus hl i2) with
              | True ->
                begin match r with
                  | MEmpty -> minvalid_arg
                  | MNode(l1, v, x1, r, _) ->
                    begin match gte (mheight r) (mheight l1)
                      with
                      | True ->
                        mcreate (mcreate l (Box (a, x)) l1)
                        (Box (v, x1))
                        r
                      | False ->
                        begin match l1 with
                          | MEmpty -> minvalid_arg
                          | MNode(l1, v1, x2, r1, _) ->
                            mcreate
                            (mcreate l (Box (a, x)) l1)
                            (Box (v1, x2))
                            (mcreate r1 (Box (v, x1)) r)
                        end
                    end
                end
              | False ->
                let x1 = (* _4 *) gte hl hr in
                MNode(l,
                 a,
                 x,
                 r,
                 match x1 with
                   | True -> plus hl i1
                   | False -> plus hr i1
                )
            end

  let rec madd xb t = match xb with
      | Box (a, x) ->
        begin match t with
          | MEmpty -> MNode(MEmpty, a, x, MEmpty, i1)
          | MNode(l, v, x1, r, _) ->
            begin match compare a v with
              | Eq -> t
              | Lt ->
                mbal (madd (Box (a, x)) l) (Box (v, x1)) r
              | Gt ->
                mbal l (Box (v, x1)) (madd (Box (a, x)) r)
            end
        end

  let msingleton xb = match xb with
      | Box (a, x) -> MNode(MEmpty, a, x, MEmpty, i1)

  let rec mmin_binding t = match t with
      | MEmpty -> None
      | MNode(MEmpty, u, x, _, _) -> Some (u, x)
      | MNode(MNode(l, v, x, r, n), _, _, _, _) ->
        mmin_binding (MNode(l, v, x, r, n))

  let rec mmax_binding t = match t with
      | MEmpty -> None
      | MNode(_, u, x, MEmpty, _) -> Some (u, x)
      | MNode(_, _, _, MNode(l, v, x, r, n), _) ->
        mmax_binding (MNode(l, v, x, r, n))
