type t =
  | Empty
  | Node of t * elt * t * int

let invalid_arg = Empty

let height t = match t with
    | Empty -> i0
    | Node(_, _, _, h) -> h

let create l vb r = match vb with
    | Box v ->
      let hl = match l with
          | Empty -> i0
          | Node(_, _, _, n) -> n
      in
      let hr = match r with
          | Empty -> i0
          | Node(_, _, _, n) -> n
      in
      let x1 = gte hl hr in
      Node(l,
       v,
       r,
       match x1 with
         | True -> plus hl i1
         | False -> plus hr i1
      )

let bal l vb r = match vb with
    | Box a ->
      let hl = match l with
          | Empty -> i0
          | Node(_, _, _, n) -> n
      in
      let hr = match r with
          | Empty -> i0
          | Node(_, _, _, n) -> n
      in
      begin match gt hl (plus hr i2) with
        | True ->
          begin match l with
            | Empty -> invalid_arg
            | Node(l, v, r1, _) ->
              begin match gte (height l) (height r1) with
                | True ->
                  create l (Box v) (create r1 (Box a) r)
                | False ->
                  begin match r1 with
                    | Empty -> invalid_arg
                    | Node(l1, v1, r1, _) ->
                      create (create l (Box v) l1) (Box v1)
                      (create r1 (Box a) r)
                  end
              end
          end
        | False ->
          begin match gt hr (plus hl i2) with
            | True ->
              begin match r with
                | Empty -> invalid_arg
                | Node(l1, v, r, _) ->
                  begin match gte (height r) (height l1)
                    with
                    | True ->
                      create (create l (Box a) l1) (Box v) r
                    | False ->
                      begin match l1 with
                        | Empty -> invalid_arg
                        | Node(l1, v1, r1, _) ->
                          create (create l (Box a) l1)
                          (Box v1)
                          (create r1 (Box v) r)
                      end
                  end
              end
            | False ->
              let x1 = gte hl hr in
              Node(l,
               a,
               r,
               match x1 with
                 | True -> plus hl i1
                 | False -> plus hr i1
              )
          end
      end

let rec add xb t = match xb with
    | Box a ->
      begin match t with
        | Empty -> Node(Empty, a, Empty, i1)
        | Node(l, v, r, _) ->
          begin match compare a v with
            | Eq -> t
            | Lt -> bal (add (Box a) l) (Box v) r
            | Gt -> bal l (Box v) (add (Box a) r)
          end
      end

let singleton xb = match xb with
    | Box v -> Node(Empty, v, Empty, i1)

let rec min_binding t = match t with
    | Empty -> None
    | Node(Empty, u, _, _) -> Some u
    | Node(Node(l, v, r, n), _, _, _) ->
      min_binding (Node(l, v, r, n))

let rec max_binding t = match t with
    | Empty -> None
    | Node(_, u, Empty, _) -> Some u
    | Node(_, _, Node(l, v, r, n), _) ->
      max_binding (Node(l, v, r, n))
