
# 42 "exprbis.tex"
type expr =
  | Var of string
  | Abs of string * expr
  | App of expr * expr
  | Const of int

# 50 "exprbis.tex"
let rec eval env e = match e with
  | Var x ->
      begin match find x env with
      | Some v -> Some v
      | None -> None
      end
  | App (u, v) ->
      begin match eval env u with
      | Some (Abs (x, f)) ->
          begin match eval env v with
          | Some w -> eval (Cons ((x, w), env)) f
          | None -> None
          end
      | Some w -> None
      | None -> None
      end
  | v -> Some v

# 78 "exprbis.tex"
type ('a,'err) result =
  | Ok of 'a
  | Error of 'err

# 84 "exprbis.tex"
type ornament ('a, 'err) optres : 'a option => ('a, 'err) result with
  | Some a => Ok a
  | None => Error _

# 90 "exprbis.tex"
let eval_mes_ =
  lifting eval : _ -> _ -> ('a, 'err) optres with
  ornament * <- @id

# 119 "exprbis.tex"
let eval_mes =
  lifting eval : _ -> _ -> ('a, 'err) optres with
  ornament * <- @id
  patch #30[str__Unbound_variable]
  patch (match _a with Ok _ -> Error (#[str__Not_a_function]))
  patch (match _a with Error a -> Error (#[a]))

# 150 "exprbis.tex"
type location = Location of string * int * int

# 165 "exprbis.tex"
type expr' =
  | Var' of string
  | Abs' of string * (expr' * location)
  | App' of (expr' * location) * (expr' * location)
  | Const' of int

# 173 "exprbis.tex"
type ornament add_loc : expr => expr' * location with
  | Var x => (Var' x, _)
  | Abs (x, f) => (Abs' (x, f), _) when f : add_loc
  | App (u, v) => (App' (u, v), _) when u v : add_loc
  | Const i => (Const' i, _)


# 184 "exprbis.tex"
type ('a,'err) result' =
  | Ok' of 'a
  | Error' of 'err

# 190 "exprbis.tex"
type ornament ('a, 'mes, 'err) optres' : ('a, 'mes) result
        => ('a, 'mes * 'err) result with
  | Ok a => Ok a
  | Error b => Error (b, _)

# 197 "exprbis.tex"
let _eval_loc =
  lifting eval_mes :
     (_ * add_loc) list -> add_loc -> (_, _, _) optres'
  with ornament * <- @id

# 229 "exprbis.tex"
let eval_loc =
  lifting eval_mes : (_ * add_loc) list -> add_loc
        -> (_, _, _) optres' with
  ornament * <- @id
  patch #33[begin match e with (_, loc) -> loc (* unbound *) end]
  patch match _a with Ok(_, _b) -> Error (_c, (#[_b]))
  patch match _a with Error(_, _b) -> Error (_c, (#[_b]))

# 261 "exprbis.tex"
 let _eval_loc =
  lifting eval_mes : (_ * add_loc) list -> add_loc -> _ with
   ornament * <- @id

# 290 "exprbis.tex"
let rec free_vars e = match e with
  | Var x -> Cons (x, Nil)
  | Abs (x, f) -> remove x (free_vars f)
  | App (u, v) -> append (free_vars u) (free_vars v)
  | Const i -> Nil

# 298 "exprbis.tex"
let free_vars_loc = lifting free_vars : add_loc -> string list
    with ornament * <- @id
