
# 23 "desorn_de_bruijn.tex"
  type 'a list = Nil | Cons of 'a * 'a list
  type 'a option = None | Some of 'a

  type expr =
    | App of expr * expr
    | Const of int
    | Abs of string * expr
    | Var of string box



  let rec assoc n l = match l with
    | Nil -> None
    | Cons((a, b), q) ->
      match n with
      | Box n' ->
        match eq a n' with
        | True -> Some b
        | False -> assoc (Box n') q

  let rec eval env e =
    match e with
    | Const i -> Some (Const i)
    | App(a, b) ->
      begin
      match eval env b with
      | None -> None
      | Some e -> begin match eval env a with
        | Some (Abs(n, v)) -> eval (Cons((n, e), env)) v
        | _ -> None
        end
      end
    | Abs(n, v) -> Some (Abs(n, v))
    | Var(n) -> assoc n env
