type expr_de_bruijn =
  | App' of expr_de_bruijn * expr_de_bruijn
  | Const' of int
  | Abs' of expr_de_bruijn
  | Var' of int box

let rec assoc' n l = match l with
    | Nil -> None
    | Cons(b, q) ->
      begin match n with
        | Box _ ->
          begin match eq #19 #13 with
            | True -> Some b
            | False -> assoc' (Box #5) q
          end
      end

let rec assoc' n l = match l with
    | Nil -> None
    | Cons(b, q) ->
      begin match n with
        | Box n' ->
          begin match eq zero n' with
            | True -> Some b
            | False -> assoc' (Box (prev n')) q
          end
      end

let rec eval_bruijnified env e = match e with
    | App'(a, b) ->
      begin match eval_bruijnified env b with
        | None -> None
        | Some a1 ->
          begin match eval_bruijnified env a with
            | (((None | Some (App'(_, _))) | Some (Const' _))
              | Some (Var' _)) -> None
            | Some (Abs' e) ->
              eval_bruijnified (Cons(a1, env)) e
          end
      end
    | Const' i -> Some (Const' i)
    | Abs' e -> Some (Abs' e)
    | Var' n -> (lifting #8 of assoc) n env

let rec eval_bruijnified env e = match e with
    | App'(a, b) ->
      begin match eval_bruijnified env b with
        | None -> None
        | Some a1 ->
          begin match eval_bruijnified env a with
            | (((None | Some (App'(_, _))) | Some (Const' _))
              | Some (Var' _)) -> None
            | Some (Abs' e) ->
              eval_bruijnified (Cons(a1, env)) e
          end
      end
    | Const' i -> Some (Const' i)
    | Abs' e -> Some (Abs' e)
    | Var' n -> assoc' n env
