type expr =
  | Abs of (expr -> expr)
  | App of expr * expr
  | Const of int

let rec eval e = match e with
    | Abs _ -> Some e
    | App(u, v) ->
      begin match eval u with
        | ((None | Some (App(_, _))) | Some (Const _)) ->
          None
        | Some (Abs f) -> eval (f v)
      end
    | Const _ -> Some e

let rec eval e = match e with
    | Abs _ -> Some e
    | App(u, v) ->
      begin match eval u with
        | ((None | Some (App(_, _))) | Some (Const _)) ->
          None
        | Some (Abs f) -> eval (f v)
      end
    | Const _ -> Some e
