
  type ornament ('a, 'b) erase_box: 'a box => 'b box with
    | Box _ => Box _

type expr_de_bruijn =
    | App' of expr_de_bruijn * expr_de_bruijn
    | Const' of int
    | Abs' of expr_de_bruijn
    | Var' of int box

type ornament bruijnification: expr => expr_de_bruijn with
  | Var a => Var' a when a: (string, int) erase_box
  | App (a, b) => App'(a, b) when a b: bruijnification
  | Const i => Const' i
  | Abs(_, e) => Abs' e when e: bruijnification

type ornament env: (string * expr) list => expr_de_bruijn list with
  | Nil => Nil
  | Cons((_, a), q) => Cons(a, q) when q: env, a: bruijnification

let assoc' =
  lifting assoc: (string, int) erase_box -> env -> _ option with
  ornament * <- bool

let assoc' =
  lifting assoc: (string, int) erase_box -> env -> _ option with
  ornament * <- bool
  patch #5[prev (match n with Box n' -> n')]
  patch #20[zero]
  patch #14[match n with Box a -> a]

let eval_bruijnified =
  lifting eval: env -> bruijnification -> bruijnification option

let eval_bruijnified =
  lifting eval: env -> bruijnification -> bruijnification option
  with
  lifting #10 <- assoc'
