
type location = Location of string * int * int
type expr_loc =
  | Abs' of (expr_loc -> expr_loc) * location
  | App' of expr_loc * expr_loc * location
  | Const' of int * location

type ('a,'err) result =
  | Ok of 'a
  | Error of 'err

let rec eval_loc e = match e with
    | App'(u, v, loc) ->
      begin match eval_loc u with
        | Ok (Abs'(f, _)) -> eval_loc (f v)
        | Ok (App'(_, _, _)) -> Error loc
        | Ok (Const'(_, _)) -> Error loc
        | Error x -> Error x
      end
    | _ -> Ok e

type expr' =
  | Abs'' of ((expr' * location) -> (expr' * location))
  | App'' of (expr' * location) * (expr' * location)
  | Const'' of int

let rec eval_loc2 e = match e with
    | (App''(u, v), loc) ->
      begin match eval_loc2 u with
        | Ok (Abs'' f, _) -> eval_loc2 (f v)
        | Error x -> Error x
        | _ -> Error loc
      end
    | _ -> Ok e
