
type nat = | Z
           | S of nat

type 'a list =
  | Nil
  | Cons of 'a * 'a list

let rec append m n = match m with
  | Nil -> n
  | Cons(a, m') -> Cons(a, append m' n)

let rec list_length n = match n with
  | Nil -> Z
  | Cons(_, m) -> S (list_length m)

let rec map_list f n = match n with
  | Nil -> Nil
  | Cons(x, n') -> Cons(f x, map_list f n')
