
type binop' =
  | Add'
  | Mul'

type expr' =
  | Const' of int
  | Binop' of binop' * expr' * expr'

type ornament oexpr : expr => expr' with
  | Const ( i ) => Const' ( i )
  | Add ( u , v ) => Binop' ( Add' , u , v )  when u v : oexpr
  | Mul ( u , v ) => Binop' ( Mul' , u , v )  when u v : oexpr

let eval' = lifting eval : oexpr -> int

let eval' = lifting eval : _ with ornament * <- oexpr, @id

type ornament ioexpr : expr' => expr with
  | Const' ( i ) => Const ( i )
  | Binop' ( Add' , u , v ) => Add ( u , v ) when u v : ioexpr
  | Binop' ( Mul' , u , v ) => Mul ( u , v ) when u v : ioexpr

let rec eval' = function
  | Const' x -> x
  | Binop'(Add', x, x') -> add (eval' x) (eval' x')
  | Binop'(Mul', x, x') -> mul (eval' x) (eval' x')

let eval'' = lifting eval'  : rev_oexpr -> int

let rec copy = function
  | Const (i) -> Const i
  | Add ( u , v ) ->  Add ( copy u , copy v )
  | Mul ( u , v ) -> Mul ( copy u , copy v )

let  expr2expr' = lifting copy : expr -> oexpr
