
type binop' =
  | Add'
  | Mul'

type expr' =
  | Const' of int
  | Binop' of binop' * expr' * expr'
  | Abs' of (expr' -> expr' option)
  | App' of expr' * expr'

type ornament oexpr : expr => expr' with
  | Const ( i ) => Const' ( i )
  | Add ( u , v ) => Binop' ( Add' , u , v ) when u v : oexpr
  | Mul ( u , v ) => Binop' ( Mul' , u , v ) when u v : oexpr
  | Abs f => Abs' f when f : oexpr -> oexpr option
  | App ( u , v ) => App' ( u , v ) when u v : oexpr

let eval' = lifting eval : oexpr -> oexpr option
  with ornament * <- @id

type expr'' =
  | Const'' of int
  | Binop'' of binop' * expr'' * expr''
  | Abs'' of (value'' -> value'' option)
  | App'' of expr'' * expr''
and value'' =
  | Int'' of int
  | Fun'' of (value'' -> value'' option)

type ornament oexpr' : expr' => expr'' with
  | Const' ( i ) => Const'' ( i )
  | Binop' ( o , u , v ) => Binop'' ( o , u , v ) when u v : oexpr'
  | Abs' f => Abs'' f when f : oval' -> oval' option
  | App' ( u , v ) => App'' ( u , v ) when u v : oexpr'
and oval' : expr' => value'' with
  | Const' i => Int'' i
  | Abs' f => Fun'' f when f : oval' -> oval' option
  | Binop'(o,u,v) => ~
  | App'(u,v) => ~

let eval'' = lifting eval' : oexpr' -> oval' option
  with ornament * <- @id
