
type 'a option =
  | Some of 'a
  | None

type expr =
  | Abs of (expr -> expr)
  | App of expr * expr
  | Const of int

let rec eval e = match e with
  | App (u, v) ->
      begin match eval u with Some (Abs f) -> eval (f v) | _ -> None end
  | _ -> Some(e)
