
type expr =
  | Const of bool
  | Abs of (expr -> expr)
  | App of expr * expr

let rec eval e = match e with
    | Const i -> Some (Const i)
    | Abs f -> Some (Abs f)
    | App (u, v) ->
      begin match eval u with
        | Some (Abs f) ->
          begin match eval v with
            | Some x -> eval (f x)
            | None -> None
          end
        | _ -> None
      end

let cval x = match x with
  | App (u, v) -> fail
  | Const i -> Const i
  | Abs f -> Abs f

let id = Abs (fun x -> cval x)
let xx = Abs (fun x -> App (cval x, cval x))
let z = App (App (xx, id), Const True)
let v _x = eval z
