
type expr' =
  | Val of value
  | App' of expr' * expr'
and value =
  | Const' of bool
  | Abs' of (value -> expr')

type ornament oexpr : expr => expr' with
  | Const  i  => Val (Const' i)
  | Abs f => Val (Abs' f) when f : oval -> oexpr
  | App ( u , v ) => App' ( u , v ) when u v : oexpr
and oval : expr => value with
  | Const i => Const' i
  | Abs f => Abs' f when f : oval -> oexpr
  | App (u,v) => ~

let eval' = lifting eval : oexpr -> oval option
  with ornament * <- @id

let cval' = lifting cval : oval -> oexpr
let id' = lifting id : oexpr
let xx' = lifting xx : oexpr
let z' = lifting z : oexpr
let v' = lifting v : _ -> oval option
