
type nat =
  | Z
  | S of nat

type 'a list =
  | Nil
  | Cons of 'a * 'a list

type 'a bilist =
  | Nil0
  | Cons1 of 'a * 'a bilist
  | Cons2 of 'a * 'a bilist

type 'a maybelist =
  | NilM
  | ConsNone of 'a maybelist
  | ConsSome of 'a * 'a maybelist

let id = fun x -> x
let zero = Z

let rec add m n =
  match m with
  | Z -> n
  | S m' -> S(add m' n)

type ornament 'a natlist : nat => 'a list with
  | Z => Nil
  | S n => Cons (_, n) when n : 'a natlist

let id2 = lifting id

let nil = lifting zero : _ natlist

let _append = lifting add : _ natlist -> _ natlist -> _ natlist

let append = lifting add : _ natlist -> _ natlist -> _ natlist with
  patch #3[match m with Cons(a,_) -> a]

let rec append ml nl =
    match ml with
    | Nil -> nl
    | Cons(a,ml') -> Cons(a, append ml' nl)

let add2 = lifting add with
  ornament * <- @id

type ornament 'a listbilist : 'a list => 'a bilist with
  | Nil => Nil0
  | Cons(a,l) => (Cons1(a,l) | Cons2(a,l)) when l : 'a listbilist

let append2 = lifting append with
  ornament * <- listbilist
  patch #3[match ml with Cons1(_,_) -> Left(()) | Cons2(_,_) -> Right(())]

type ornament natunit : nat => () with
  | Z => ()
  | S _ => ~

type ornament 'a natmaybelist : nat => 'a maybelist with
  | Z => NilM
  | S(x) => (ConsNone(x) | ConsSome(_,x)) when x : 'a natmaybelist

let add0 = lifting add with
  ornament * <- natunit

let addmaybe = lifting add with
  ornament * <- natmaybelist
  patch #3[match m with ConsNone(_) -> Left(()) | ConsSome(a,_) -> Right(a)]

let rec equal_nat m n =
  match (m, n) with
  | (Z, Z) -> True
  | (S m', S n') -> equal_nat m' n'
  | _ -> False

let equal_length = lifting equal_nat : _ natlist -> _ natlist -> bool
  with ornament * <- @id
