
type 'a map = MEmpty | MNode of 'a map * elt * 'a * 'a map * int

type ornament 'a setmap : t => 'a map with
     | Empty => MEmpty
     | Node(l,v,r,n) => MNode(l,v,_,r,n) when l r : 'a setmap

type ornament ('a,'new) box2 : 'a box => ('a * 'new) box with
     | Box a => Box (a,_)

type ornament ('a, 'b) option2 : 'a option => ('a * 'b) option with
     | None => None
     | Some u => Some (u, _)

let minvalid_arg = lifting invalid_arg : _ setmap

let mheight = lifting height : _ setmap -> _

let mcreate = lifting create : _ setmap -> _ box2 -> _ setmap -> _ setmap with
              | #6 <- (match vb with Box (_,x) -> x)

let mbal = lifting bal : _ setmap -> _ box2 -> _ setmap -> _ setmap with
  ornament * <- setmap, box2
  | #84, #107 <- (match l with MNode(_,_,x,_,_) -> x)
  | #22, #47 <- (match r with MNode(_,_,x,_,_) -> x)
  | #14, #31, #49, #75, #100 <- (match vb with Box(_,x) -> x)
  | #29 <- (match r with MNode(MNode(_,_,x,_,_),_,_,_,_) -> x)
  | #82 <- (match l with MNode(_,_,_,MNode(_,_,x,_,_),_) -> x)

let madd = lifting add : _ box2 -> _ setmap -> _ setmap with
  | #5, #17, #28, #49 <- (match xb with Box(_,x) -> x)
  | #15, #8, #26 <- (match t with MNode(_,_,x,_,_) -> x)

let msingleton = lifting singleton : _ box2 -> _ setmap with
  | #3 <- (match xb with Box (_,x) -> x)


let mmin_binding = lifting min_elt : _ setmap -> _ option2 with
  | #4 <-  (match t with MNode(_,_,x,_,_) -> x)

let mmax_binding = lifting max_elt : _ setmap -> _ option2 with
  | #4 <- (match t with MNode(_,_,x,_,_) -> x)
