type nat =
  | Z
  | S of nat

type 'a list =
  | Nil
  | Cons of 'a * 'a list

type 'a bilist =
  | Nil0
  | Cons1 of 'a * 'a bilist
  | Cons2 of 'a * 'a bilist

type 'a maybelist =
  | NilM
  | ConsNone of 'a maybelist
  | ConsSome of 'a * 'a maybelist

let id2 x = x

let nil = Nil

let rec _append m n = match m with
    | Nil -> n
    | Cons(_, m') -> Cons(#3, _append m' n)

let rec append m n = match m with
    | Nil -> n
    | Cons(a, m') -> Cons(a, append m' n)

let rec add2 m n = match m with
    | Z -> n
    | S m' -> S (add2 m' n)

let rec append2 ml nl = match ml with
    | Nil0 -> nl
    | Cons1(a, ml') -> Cons1(a, append2 ml' nl)
    | Cons2(a, ml') -> Cons2(a, append2 ml' nl)

let add0 m n = n

let rec addmaybe m n = match m with
    | NilM -> n
    | ConsNone m' -> ConsNone (addmaybe m' n)
    | ConsSome(a, m') -> ConsSome(a, addmaybe m' n)

let rec equal_length m n = match (m, n) with
    | (Nil, Nil) -> True
    | (Cons(_, n), Cons(_, n1)) -> equal_length n n1
    | _ -> False
