
# 73 "patch_language.tex"
  type expr' =
    | Abs' of ((expr' * location) -> (expr' * location))
    | App' of (expr' * location) * (expr' * location)
    | Const' of int

# 86 "patch_language.tex"
type ornament add_loc : expr => expr' * location with
  | Abs f => (Abs' f, _) when f : add_loc -> add_loc
  | App (u, v) => (App' (u, v), _) when u v : add_loc
  | Const (i) => (Const' (i), _)

type ornament ('a, 'err) optres : 'a option => ('a, 'err) result with
  | Some a => Ok a
  | None => Error _

# 98 "patch_language.tex"
let _eval_incomplete = lifting eval : _ list -> add_loc -> (add_loc, location) optres

# 119 "patch_language.tex"
let eval' = lifting eval: _ list -> add_loc -> (_, _) optres with
  | #6, #8 <- (match e with (_, loc) -> loc)
  | #13 <- (match res_u with Error x -> x)

# 143 "patch_language.tex"
let eval' = lifting eval: _ list -> add_loc -> (_, _) optres with
  | (match _a with Error x -> Error (#a)) => #a <- x
  | (match _a with Ok _ -> Error (#a)) => #a <- (match e with (_, loc) -> loc)

# 186 "patch_language.tex"
type expr2 =
  | Abs2    of (expr2 -> expr2)
  | App2    of expr2 * expr2
  | Const2  of int
  | Add2    of expr2 * expr2

# 194 "patch_language.tex"
type relation add_add: expr => expr2 with
| Abs f      =>  Abs2 f when f: add_add -> add_add
| App(a, b)  =>  App2(a, b) when a b: add_add
| Const(i)   =>  Const2(i)
| ~          =>  Add2(a, b) when a b: add_add

# 208 "patch_language.tex"
let eval2 = lifting eval: _ -> add_add -> _ option

# 226 "patch_language.tex"
let eval2 = lifting eval: _ -> add_add -> _ option with
  | (match _a with Some(Add2(_, _)) -> #a) => #a <- None
  | (match e with Add2(u, v) -> #a) => #a <- (let u' = eval2 env u in
      let v' = eval2 env v in
      match u' with
      | Some (Const2 i) ->
          begin match v' with
          | Some (Const2 j) ->
            Some (Const2 (plus i j))
          | _ -> None end
      | _ -> None)


# 272 "patch_language.tex"
type expr2' =
  | Abs2'   of ((expr2' * location) -> (expr2' * location))
  | App2'   of (expr2' * location) * (expr2' * location)
  | Add2'   of (expr2' * location) * (expr2' * location)
  | Const2' of int

# 279 "patch_language.tex"
type ornament add_loc : expr2 => expr2' * location with
  | Abs2 f      => (Abs2' f, _) when f : add_loc -> add_loc
  | App2 (u, v) => (App2' (u, v), _) when u v : add_loc
  | Add2 (u, v) => (Add2' (u, v), _) when u v : add_loc
  | App2 (u, v) => (App2' (u, v), _) when u v : add_loc
  | Const2 (i)  => (Const2' (i), _)

# 290 "patch_language.tex"
let eval2' = lifting eval2: _ list -> add_loc -> (_, _) optres

# 326 "patch_language.tex"
let eval2' = lifting eval2: _ list -> add_loc -> (_, _) optres with
  | (match _a with Error x -> Error (#a)) => #a <- x
  | (match _a with Ok _ -> Error (#a)) => #a <- (match e with (_, loc) -> loc)

# 362 "patch_language.tex"
let eval2' = lifting eval2: _ list -> add_loc -> (_, _) optres with
  | (match _a with Error x -> Error (#a)) => #a <- x
  | (match _a with Ok _ -> Error (#a)) => #a <- (match e with (_, loc) -> loc)
  | (Ok (Const2' (plus _a _b), #a)) => #a <- (match e with (Add2'(_, _), loc) -> loc)

# 430 "patch_language.tex"
type ornament add_loc' : expr_big => expr_big' * location with
  | Absb f          =>  (Absb' f, _)          when f : add_loc' -> add_loc'
  | Appb (u, v)     =>  (Appb' (u, v), _)     when u v : add_loc'
  | Addb (u, v)     =>  (Addb' (u, v), _)     when u v : add_loc'
  | Constb (i)      =>  (Constb' (i), _)
  | Varb i          =>  (Varb' i, _)
  | Letb (s, u, v)  =>  (Letb' (s, u, v), _)  when u v : add_loc'

# 490 "patch_language.tex"
let eval_desorn = lifting eval_big: _ -> rev_add_loc' -> _ rev_optres

# 541 "patch_language.tex"
let eval_desorn_orn = lifting eval_desorn: _ list -> add_loc' -> (_, _) optres with
  | (match _a with Error x -> Error (#a)) => #a <- x
  | (match _a with Ok _ -> Error (#a)) => #a <- (match e with (_, loc) -> loc)
  | (Ok (Constb' (plus _a _b), #a)) => #a <- (match e with (Addb'(_, _), loc) -> loc)

# 594 "patch_language.tex"
let eval_desorn_orn = lifting eval_desorn: _ list -> add_loc' -> (_, _) optres with
  | (match _a with Error x -> Error (#a)) => #a <- x
  | (match _a with Ok _ -> Error (#a)) => #a <- (match e with (_, loc) -> loc)
  | (Ok (Constb' (plus _a _b), #a)) => #a <- (match e with (Addb'(_, _), loc) -> loc)
  | (match _a with None -> Error (#a)) => #a <- (match e with (_, loc) -> loc)
