type tree =
  | SEmpty
  | SNode of tree * elt * tree

let rec simpl_mem x = function
  | SEmpty -> False
  | SNode(l, y, r) ->
    begin match compare x y with
      | Lt -> simpl_mem x l
      | Gt -> simpl_mem x r
      | Eq -> True
    end

let simpl_singleton x = SNode(SEmpty, x, SEmpty)

let simpl_add x s = let a = (let rec add_aux t = match t
        with
        | SEmpty -> SNode(SEmpty, x, SEmpty)
        | SNode(l, y, r) ->
          begin match #40 with
            | Left _ ->
              begin match compare x y with
                | Lt -> SNode(add_aux l, y, r)
                | Gt -> SNode(l, y, add_aux r)
                | Eq -> t
              end
            | Right _ ->
              begin match compare x y with
                | Lt ->
                  (lifting #36 of balance_left) (add_aux l)
                  y
                  r
                | Gt ->
                  (lifting #28 of balance_right) l y
                  (add_aux r)
                | Eq -> t
              end
          end
    in
    add_aux)
    s
  in
  match a with
    | SEmpty -> a
    | SNode(a1, e, b) ->
      begin match #8 with
        | Left _ -> SNode(a1, e, b)
        | Right _ -> a
      end

let simpl_add x s = let a = (let rec add_aux t = match t
        with
        | SEmpty -> SNode(SEmpty, x, SEmpty)
        | SNode(l, y, r) ->
          begin match compare x y with
            | Lt -> SNode(add_aux l, y, r)
            | Gt -> SNode(l, y, add_aux r)
            | Eq -> t
          end
    in
    add_aux)
    s
  in
  match a with
    | SEmpty -> a
    | SNode(a, e, b) -> SNode(a, e, b)
