
# 50 "set.tex"
type t = Empty | Node of t * elt * t * int
let invalid_arg = Empty

let height t = match t with
    Empty -> i0
  | Node(_, _, _, h) -> h

let create l vb r =
  match vb with
  | Box v ->
  let hl = match l with Empty -> i0 | Node(_,_,_,h) -> h in
  let hr = match r with Empty -> i0 | Node(_,_,_,h) -> h in
  Node(l, v, r, (match gte hl hr with True -> plus hl i1 | False -> plus hr i1))

let bal l vb r =
  match vb with
  | Box v ->
  let hl = match l with Empty -> i0 | Node(_,_,_,h) -> h in
  let hr = match r with Empty -> i0 | Node(_,_,_,h) -> h in
  match gt hl (plus hr i2) with
  | True ->
     begin
       match l with
         Empty -> invalid_arg
       | Node(ll, lv, lr, _) ->
          match gte (height ll) (height lr) with
          | True -> create ll (Box lv) (create lr (Box v) r)
          | False -> begin
              match lr with
                Empty -> invalid_arg
              | Node(lrl, lrv, lrr, _)->
                 create (create ll (Box lv) lrl) (Box lrv) (create lrr (Box v) r)
            end
     end
  | False ->
     begin match gt hr (plus hl i2) with
           | True -> begin
                     match r with
                       Empty -> invalid_arg
                     | Node(rl, rv, rr, _) ->
                        match gte (height rr) (height rl) with
                        | True -> create (create l (Box v) rl) (Box rv) rr
                        | False -> begin
                            match rl with
                              Empty -> invalid_arg
                            | Node(rll, rlv, rlr, _) ->
                               create (create l (Box v) rll) (Box rlv) (create rlr (Box rv) rr)
                          end
                   end
           | False ->  Node(l, v, r, (match gte hl hr with True -> plus hl i1 | False -> plus hr i1))
     end

let rec add xb t =
  match xb with
  | Box x ->
     match t with
       Empty -> Node(Empty, x, Empty, i1)
     | Node(l, v, r, _) ->
        match compare x v with
        | Eq -> t
        | Lt -> bal (add (Box x) l) (Box v) r
        | Gt -> bal l (Box v) (add (Box x) r)

let singleton xb =
  match xb with
  | Box x -> Node(Empty, x, Empty, i1)

let rec min_elt t = match t with
    Empty -> None
  | Node(Empty, v, r, _) -> Some v
  | Node(l, v, r, _) -> min_elt l

let rec max_elt t = match t with
    Empty -> None
  | Node(l, v, Empty, _) -> Some v
  | Node(l, v, r, _) -> max_elt r

