
# 13 "unfolding_generic.tex"
type 'a gen =
  | Pair of ('a gen * 'a gen)
  | Value of 'a
  | Unit

# 21 "unfolding_generic.tex"
let rec gen_map f x = match x with
  | Pair(u,v) -> Pair(gen_map f u, gen_map f v)
  | Value x -> Value (f x)
  | Unit -> Unit

# 29 "unfolding_generic.tex"
type 'a list =
  | Nil
  | Cons of ('a * 'a list)

# 36 "unfolding_generic.tex"
type ornament 'a gen_list : 'a gen => 'a list with
| Unit => Nil
| Pair t => Cons t when t : ('a gen_elem * 'a gen_list)
| Value x => ~
and 'a gen_elem : 'a gen => 'a with
| Value x => x
| Unit => ~
| Pair t => ~ when t : ('a gen_elem * 'a gen_list)

# 48 "unfolding_generic.tex"
let map_list = lifting gen_map : ('a -> 'b) -> 'a gen_list -> 'b gen_list

# 61 "unfolding_generic.tex"
type 'a tree =
  | Leaf
  | Node of ('a * ('a tree * 'a tree))

# 66 "unfolding_generic.tex"
type ornament 'a gen_tree : 'a gen => 'a tree with
| Unit => Leaf
| Pair t => Node t when t : ('a gen_value * 'a gen_treepair)
| Value x => ~
and 'a gen_value : 'a gen => 'a with
| Value x => x
| Unit => ~
| Pair t => ~ when t : ('a gen_tree * 'a gen_tree)
and 'a gen_treepair : 'a gen => 'a tree * 'a tree with
| Unit => ~
| Pair t => t when t : ('a gen_tree * 'a gen_tree)
| Value x => ~

# 80 "unfolding_generic.tex"
let map_tree = lifting gen_map : ('a -> 'b) -> 'a gen_tree -> 'b gen_tree
