type 'a gen =
  | Pair of ('a gen * 'a gen)
  | Value of 'a
  | Unit

type 'a list =
  | Nil
  | Cons of ('a * 'a list)

let rec map_list f x = match x with
    | Cons (u, v) -> Cons (gen_map_auto1 f u, map_list f v)
    | Nil -> Nil
 and gen_map_auto1 f x = f x

type 'a tree =
  | Leaf
  | Node of ('a * ('a tree * 'a tree))

let rec map_tree f x = match x with
    | Node (u, v) ->
      Node (gen_map_auto3 f u, gen_map_auto2 f v)
    | Leaf -> Leaf
 and gen_map_auto2 f x = match x with
    | (u, v) -> (map_tree f u, map_tree f v)
 and gen_map_auto3 f x = f x
