include Error.Loc
include Id
open Util

(* implicit eML with shallow pattern matching *)
module ImplicitEml = struct
  type expr_aux =
    | Var of user_id * Ast.user_ty option (* x (monomorphic) or (x @ T) *)
    | Let of bool * (user_id * expr) list * expr (* let [rec] (x = e and ..) in e *)
    | Match of expr * (user_id * user_id list * expr) list (*  match e with (c(x..) => e |..) *)
    | Con of user_id * expr list (* c(e..) *)
    | Abs of user_id * expr (* fun x => e *)
    | App of expr * expr (* e_1 e_2 *)
    | Type of expr * Ast.user_ty (* (e : T) *)
   and expr = expr_aux * loc
end

module ExplicitGml = Ast.Explicit.E
