let rec collapse = function
  | [a] -> [a]
  | [] -> []
  | (i, l)::(i', l')::q when i = i'-> collapse ((i, l ^ "\n\n" ^ l')::q)
  | t1::t2::q -> t1 :: collapse (t2::q)

let load_string s =
  let s = Js.to_string s in
  try
    let _, _, _, output = Main.load_ml_string s Main.initial_env in
    let blks = Main.output_to_blk output
               |> collapse
               |> List.map (fun (i, l) -> (i - 1, Js.string l))
               |> Array.of_list
               |> Js.array in
    (1, Main.output_to_str output |> Js.string, -1, -1, -1, -1, Js.string "", blks)
  with Error.Error (Error.Loc.Loc (_, start, end_), s) ->
    (2, Js.string "", start.Lexing.pos_lnum, start.Lexing.pos_cnum - start.Lexing.pos_bol,
     end_.Lexing.pos_lnum, end_.Lexing.pos_cnum - end_.Lexing.pos_bol,
     Js.string s, Js.array [||])

let _ =
  Js.export "ocamlorn" (object%js
    method loadString s =
      load_string s
  end)


let () = Worker.set_onmessage (fun s ->
  let a = load_string s in
  Worker.post_message a)
