type binop =
  | Add

type expr =
  | Const of int
  | Binop of binop * expr * expr

let rec eval e = match e with
    | Const i -> i
    | Binop(Add, u, v) -> add (eval u) (eval v)

let rec evalop e = match e with
  | Const i -> i
  | Binop(op, u, v) ->
        (match op with Add -> add) (evalop u) (evalop v)

type binop' =
  | Add'
  | Mul'

type expr' =
  | Const' of int
  | Binop' of binop' * expr' * expr'

type ornament aexpr : expr => expr' with
  | Const ( i ) => Const' ( i )
  | Binop (Add, u , v ) => Binop' (Add', u , v ) when u v : aexpr
  | ~ => Binop' (Mul', _ , _)

let eval' = lifting eval  : aexpr -> _
   with (match _e with Binop' (Mul', u, v) -> #a) => #a <- mul (eval' u) (eval' v) 

type ornament aexpr' : expr => expr' with
  | Const ( i ) => Const' ( i )
  | Binop (op, u , v ) => Binop' (op, u , v ) when op : aop, u v : aexpr'

and aop : binop => binop' with
  | Add => Add'
  | ~ => Mul'
       
let eval'' = lifting eval  : aexpr' -> _
   with (match _e with Binop' (Mul', u, v) -> #a) => #a <- mul (eval' u) (eval' v) 

let eval''' = lifting eval  : aexpr' -> _
   with (match _e with Binop' (Mul', u, v) -> #a) => #a <- i0

let evalop' = lifting evalop  : aexpr' -> _
   with (match _op with Mul' -> #a) => #a <- mul
