type 'a list =
  | Nil
  | Cons of 'a * 'a list

type tag = Li | Ul | Default | Text
type string = String

type node = Node of tag * string * (node list)
type node_notag = Node' of string * (node_notag list)


type ornament tagging: node_notag => node with
| Node'(s, l) => Node(_, s, l) when l: tagging list

let rec fix_tags a =
  let rec change_children l =  match l with
    | Nil -> Nil
    | Cons (t, q) -> begin match t with
        | Node(tag, s, l) -> match a with
          | Node(Ul, _, _) -> Cons (fix_tags (Node(Li, s, l)), change_children q)
          | _ -> Cons(fix_tags t, Nil)
      end
  in
  match a with
  | Node(tag, s, l) -> Node(tag, s, change_children l)

let fix_tags' = lifting fix_tags: rev_tagging -> rev_tagging with
  | ornament #19 <- tag
  | #22 <- Ul
