type nat = | Z
           | S of nat

type 'a list =
  | Nil
  | Cons of 'a * 'a list

let rec append m n = match m with
    | Nil -> n
    | Cons(a, m') -> Cons(a, append m' n)

let rec list_length n = match n with
    | Nil -> Z
    | Cons(_, m) -> S (list_length m)

let rec list2nat n = match n with
    | Nil -> Z
    | Cons(_, m) -> S (list2nat m)


type ornament 'a natlist : nat => 'a list with
  | Z => Nil
  | S xs => Cons(_,xs) when xs : 'a natlist

let add = lifting append: _ rev_natlist -> _ rev_natlist -> _
let nat2int = lifting list_length: _ rev_natlist -> nat
let copy = lifting list2nat: _ rev_natlist -> nat
