type 'a option = None | Some of 'a 
type 'a tree = Empty | Node of 'a * 'a forest
and 'a forest = Nil | Cons of 'a tree * 'a forest

type 'a bint = Bil | Bin of 'a * 'a bint * 'a bint

let tree_size t =
  let rec tree_size t = 
    match t with
    | Empty -> zero
    | Node (n, f) -> succ (forest_size f)
  and forest_size f =
    match f with
    | Nil -> zero
    | Cons (t, f) -> add (tree_size t) (forest_size f)
  in tree_size t

type ornament 'a treebil : 'a tree => 'a option bint with
    Empty => Bil
  | Node (n, Nil) => Bin (Some n, Bil, Bil) 
  | Node (n, Cons (t, f)) => Bin (Some n, t, f)
                            when t : 'a treebil, f : 'a forestbil
and 'a forestbil : 'a forest => 'a option bint with
  | Nil => Bil
  | Cons (t, f) => Bin (None, t, f) when t : 'a treebil, f : 'a forestbil 
    

