type 'a gsum = GSumZ of 'a gprod | GSumS of 'a gsum
and 'a gprod = GNil | GCons of 'a gval * 'a gprod
and 'a gval = GData of 'a gsum | GParam of 'a

let gmap f =
  let rec gsum x = match x with
    | GSumZ p -> GSumZ (gprod p)
    | GSumS s -> GSumS (gsum s)
  and gprod x = match x with
    | GNil -> GNil
    | GCons(v,vs) -> GCons(gval v, gprod vs)
  and gval x = match x with
    | GData s -> GData (gsum s)
    | GParam y -> GParam (f y)
  in
  gval

type u = U
(* Lists, reassociated *)
type 'a alist = ANil of u | ACons of ('a * ('a alist * u))

(* Lists, normal *)
type 'a list = Nil | Cons of 'a * 'a list

type ornament 'a gval_list : 'a gval => 'a alist with
| GData s => s when s : 'a gsum1_list
| GParam x => ~
and 'a gval_val : 'a gval => 'a with
| GData s => ~ when s : 'a gsum1_list
| GParam x => x
and 'a gsum1_list : 'a gsum => 'a alist with
| GSumZ p => ANil p when p : 'a gprodNil0_list
| GSumS s => ACons s when s : 'a gsum0_list
and 'a gsum0_list : 'a gsum => ('a * ('a alist * u)) with
| GSumZ p => p when p : 'a gprodCons2_list
| GSumS s => ~ when s : 'a gsum0_list
and 'a gprodNil0_list : 'a gprod => u with
| GNil => U
| GCons(v,vs) => ~ when v : 'a gval_list, vs : 'a gprodNil0_list
and 'a gprodCons0_list : 'a gprod => u with
| GNil => U
| GCons(v,vs) => ~ when v : 'a gval_list, vs : 'a gprodCons0_list
and 'a gprodCons1_list : 'a gprod => ('a alist * u) with
| GNil => ~
| GCons(v,vs) => (v,vs) when v : 'a gval_list, vs : 'a gprodCons0_list
and 'a gprodCons2_list : 'a gprod => 'a * ('a alist * u) with
| GNil => ~
| GCons(v,vs) => (v,vs) when v : 'a gval_val, vs : 'a gprodCons1_list

let gmap_unfolded f =
  let rec gsum0 x = match x with
    | GSumZ p -> GSumZ (gprodCons2 p)
    | GSumS s -> GSumS (gsum0 s)
  and gsum1 x = match x with
    | GSumZ p -> GSumZ (gprodNil0 p)
    | GSumS s -> GSumS (gsum0 s)
  and gprodNil0 x = match x with
    | GNil -> GNil
    | GCons(v,vs) -> GCons(gval_list v, gprodNil0 vs)
  and gprodCons2 x = match x with
    | GNil -> GNil
    | GCons(v,vs) -> GCons(gval_val v, gprodCons1 vs)
  and gprodCons1 x = match x with
    | GNil -> GNil
    | GCons(v,vs) -> GCons(gval_list v, gprodCons0 vs)
  and gprodCons0 x = match x with
    | GNil -> GNil
    | GCons(v,vs) -> GCons(gval_list v, gprodCons0 vs)
  and gval_list x = match x with
    | GData s -> GData (gsum1 s)
    | GParam y -> GParam (f y)
  and gval_val x = match x with
    | GData s -> GData (gsum1 s)
    | GParam y -> GParam (f y)
  in
  gval_list

let map_alist = lifting gmap_unfolded : ('a -> 'b) -> 'a gval_list -> 'b gval_list

type ornament 'a alist_list : 'a alist => 'a list with
| ANil U => Nil
| ACons(x,xs) => Cons(x,xs) when xs : 'a alistu_list
and 'a alistu_list : ('a alist * u) => 'a list with
| (xs, U) => xs when xs : 'a alist_list

    
let map_list = lifting map_alist : ('a -> 'b) -> 'a alist_list -> 'b alist_list
  
