type 'a option =
  | None
  | Some of 'a

type ('a,'b) bioption =
  | None2
  | Some2 of 'a * 'b

type nat =
  | Z
  | S of nat

type 'a list =
  | Nil
  | Cons of 'a * 'a list

type ornament 'a natlist : nat => 'a list with
  | Z => Nil
  | S(xs) => Cons(_,xs) when xs : 'a natlist

type ornament ('a,'b) onetwoopt : 'b option =>  ('a,'b) bioption with
  | None => None2
  | Some(x) => Some2(_,x)

let unroll_nat = fun n ->
  match n with
  | Z -> None
  | S(x) -> Some(x)

let unroll_list = lifting unroll_nat : _ natlist -> _ onetwoopt with
                    #2 <- match n with Cons(x,_) -> x

let fold_nat = fun f ->
  let rec fold = fun n ->
    match n with
    | Z -> f None
    | S(x) -> f (Some (fold x))
  in
  fold

let fold_list = lifting fold_nat : (_ onetwoopt -> _) -> _ natlist -> _
                with #2 <- match n with Cons(x,_) -> x

let add = fun n -> fun m -> fold_nat (fun z -> match z with None -> m | Some(y) -> S(y)) n

let append = lifting add : _ natlist -> _ natlist -> _ natlist with
  | #2 <- (match z with Some2(x,_) -> x)
