(** Lifting to maps **)
type 'a map = MEmpty | MNode of 'a map * elt * 'a * 'a map * int

type ornament 'a setmap : t => 'a map with
     | Empty => MEmpty
     | Node(l,v,r,n) => MNode(l,v,_,r,n) when l r : 'a setmap

type ornament ('a,'new) box2 : 'a box => ('a * 'new) box with
     | Box a => Box (a,_)

type ornament ('a, 'b) option2 : 'a option => ('a * 'b) option with
     | None => None
     | Some u => Some (u, _)

let minvalid_arg = lifting invalid_arg : _ setmap

let mheight = lifting height : _ setmap -> _

let mcreate = lifting create : _ setmap -> _ box2 -> _ setmap -> _ setmap with
              | #2 <- (match vb with Box (_,x) -> x)

let mbal = lifting bal : _ setmap -> _ box2 -> _ setmap -> _ setmap with
  | ornament * <- setmap, box2
  | #67, #89 <- (match l with MNode(_,_,x,_,_) -> x)
  | #9, #33 <- (match r with MNode(_,_,x,_,_) -> x)
  | #2, #18, #35, #58, #82 <- (match vb with Box(_,x) -> x)
  | #16 <- (match r with MNode(MNode(_,_,x,_,_),_,_,_,_) -> x)
  | #65 <- (match l with MNode(_,_,_,MNode(_,_,x,_,_),_) -> x)

let madd = lifting add : _ box2 -> _ setmap -> _ setmap with
  | #2, #14, #23 <- (match xb with Box(_,x) -> x)
  | #12, #4 <- (match t with MNode(_,_,x,_,_) -> x)

let msingleton = lifting singleton : _ box2 -> _ setmap with
  | #2 <- (match xb with Box (_,x) -> x)


let mmin_binding = lifting min_elt : _ setmap -> _ option2 with
  | #2 <-  (match t with MNode(_,_,x,_,_) -> x)

let mmax_binding = lifting max_elt : _ setmap -> _ option2 with
  | #2 <- (match t with MNode(_,_,x,_,_) -> x)


type simplt = SEmpty | SNode of simplt * elt * simplt

type ornament simplification: t => simplt with
| Empty => SEmpty
| Node(l, v, r, _) => SNode(l, v, r) when l r: simplification

val max: int -> int -> int

let minvalid_arg = lifting invalid_arg: simplification
(*let mheight = lifting height: simplification -> _ with
(match t with SNode(l, _, r) -> #a) => #a <- (max (mheight l) (mheight r))*)

let mcreate = lifting create : simplification -> _ box -> simplification -> simplification
let mbal = lifting bal : simplification -> _ box -> simplification -> simplification
let madd = lifting add: _ box -> simplification -> simplification
